package cz.muni.fi.fibot.chobot;

import java.util.Random;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Strategy.BotAction;
import cz.muni.fi.fibot.World;
import java.util.ArrayList;

public class ChoBot implements Strategy {
       
    private World world;
    private Robot me;
    
    private int state;
    
    private CPU cpu;
    private PathFinder pathfinder;
    
    private BotAction lastAction;
    private boolean success;
    
    
    public ChoBot() {
        cpu = null;
        pathfinder = null;
        state = 2;
        lastAction = BotAction.SHOOT;
        success = true;
    }
    
    public void setWorld(World world) {
        this.world = world;
    }
    
    public void setRobot(Robot robot) {
        this.me = robot;
    }
    
    public void initialize() {
        try{
            cpu = new CPU(this);
            pathfinder = new PathFinder(this);           
            
            cpu.initialize();     

        } catch(Exception e){}
    }
    
    public Strategy.BotAction decide() {
        try{
            if(!success){
                cpu.setSearchDepth(cpu.getSearchDepth()-1);
            }
            success = false;
            BotAction retValue = cpu.process();
            success = true;
            
            state++;
            
            if(retValue == null){
                retValue = BotAction.TAKE;
            }
            lastAction = retValue;
            return retValue;
            
        } catch(Exception e){
            return lastAction;
        }
        
    }
    
    public World getWorld(){
        return this.world;
    }
    
    public Robot getMe(){
        return me;
    }
    
    public PathFinder getPathfinder() {
        return this.pathfinder;
    }
    
    public CPU getCPU() {
        return this.cpu;
    }
    
    
    
    
}
