/*
 * Position.java
 *
 * Created on 31. bezen 2006, 15:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.chobot;

import cz.muni.fi.fibot.Robot.Direction;

/**
 *
 * @author Andy1
 */
public class Position implements Comparable, Cloneable{
        
        private int x;
        private int y;
        private boolean shootAction;
        private Direction direction;
        
        public Position(int x, int y, Direction direction){
            this.x =x;
            this.y =y;
            this.direction = direction;
        }
        
        public Position(int x, int y){
            this.x =x;
            this.y =y;
            this.direction = null;
            this.shootAction = false;
        }
        
        public Position(Position p, Direction d){
            this.x = p.getX();
            this.y = p.getY();
            this.direction = d;
        }
        
        public int getX(){
            return x;
        }
        
        public int getY(){
            return y;
        }
        
        public Direction getDirection(){
            return direction;
        }
        
        protected void setX(int x){
            this.x = x;
        }
        
        protected void setY(int y){
            this.y=y;
        }
        
        protected void setDirection(Direction dir){
            this.direction = dir;
        }
        protected void setDirection(int dir){
            if(dir == 0){
                this.direction = Direction.LEFT;
                return;
            }
            if(dir == 1){
                this.direction = Direction.UP;
                return;
            }
            if(dir == 2){
                this.direction = Direction.RIGHT;
                return;
            }
            this.direction = Direction.DOWN;
        } 

        public void setShootAction(boolean val){
            shootAction = val;
        }
        
        public boolean isShootAction(){
            return shootAction;
        }
        
        public boolean equals(Object o) {
            if(o instanceof Position){
                    Position p = (Position) o;                    
                    if(p.getX()==getX() && p.getY()==getY() && (getDirection()==null || p.getDirection()==null || p.getDirection().equals(getDirection())))
                        return true;
                    
            }
            return false;
        }

        public int compareTo(Object o) {
            if(o instanceof Position){
                    Position p = (Position) o;            
                    
                    if( (p.getX()+p.getY()*50) > (getX()+getY()*50) )                    
                        return 1;
                    
                    else if( (p.getX()+p.getY()*50) < (getX()+getY()*50) )
                        return -1;
            }
            return 0;
        }

        public int hashCode() {
            int retValue;    
            if(direction==null)
                retValue = 10*x + 500*y;
            else
                retValue = direction.ordinal() + 10*x + 500*y;
            return retValue;
        }

        public Object clone(){
            try{
                Object o = super.clone();
                Position p =(Position) o;
                p.setShootAction(false);
                return p;
            }
            catch(CloneNotSupportedException e){
                return null;
            }            
        }
        
        public String toString(){
            return "["+x+","+y+"]"+direction+(shootAction?" -SHOOT":"");
        }        
 
    }
