/*
 * VirtualTreasure.java
 *
 * Created on 9. duben 2006, 10:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.chobot;

import java.util.ArrayList;

/**
 *
 * @author Andy1
 */
public class VirtualTreasure extends Position implements Cloneable{
    
    int value;
    int lifeTime;
    float deathSpeed;
    
    ArrayList<Position> pathFromPlayer;
    ArrayList<Position> pathFromOpponent0;
    ArrayList<Position> pathFromOpponent1;
    ArrayList<Position> pathFromOpponent2;
    
    int eta[];
    int oldeta[];
    ChoBot strategy;
    /** Creates a new instance of VirtualTreasure */
    public VirtualTreasure(int x, int y, int value, ChoBot strategy) {
        super(x,y);
        pathFromPlayer = new ArrayList();
        pathFromOpponent0 = new ArrayList();
        pathFromOpponent1 = new ArrayList();
        pathFromOpponent2 = new ArrayList();
        this.value = value;
        this.lifeTime = 0;
        this.deathSpeed = 1;
        this.strategy = strategy;
        eta = new int[3];
        oldeta = new int[3];
    }
    
    
    public void setPathFromOpponent(int index, ArrayList<Position> path){
        PathFinder p=strategy.getPathfinder();
        
        switch(index){
            case 0: pathFromOpponent0=path; 
                    oldeta[0]=eta[0];
                    eta[0] = p.getPathETA(pathFromOpponent0,strategy.getCPU().getOpponentList().get(0).getRobot().getEnergy());
                    break;
            case 1: pathFromOpponent1=path;
                    oldeta[1]=eta[1];
                    eta[1] = p.getPathETA(pathFromOpponent1,strategy.getCPU().getOpponentList().get(1).getRobot().getEnergy());
                    break;
            case 2: pathFromOpponent2=path;
                    oldeta[2]=eta[2];
                    eta[2] = p.getPathETA(pathFromOpponent2,strategy.getCPU().getOpponentList().get(2).getRobot().getEnergy());
                    break;
        }
        if(oldeta[index]==0){
            oldeta[index] = eta[index]+1;
        }
    }
    
    public void setPathFromPlayer(ArrayList<Position> path){
        pathFromPlayer = path;
    }
    
    public ArrayList<Position> getPathFromPlayer(){
        return pathFromPlayer;
    }
    
    public ArrayList<Position> getPathFromOpponent(int index){
        switch(index){
            case 0: return pathFromOpponent0;
            case 1: return pathFromOpponent1;
            case 2: return pathFromOpponent2;
        }
        return null;
    }
    
    public void validateLifeTime(){
        PathFinder p = strategy.getPathfinder();
        this.lifeTime = Integer.MAX_VALUE;
        int size = pathFromOpponent0 == null ? Integer.MAX_VALUE : eta[0];
        this.lifeTime = Math.min(lifeTime, size);
        size = pathFromOpponent1 == null ? Integer.MAX_VALUE : eta[1];
        this.lifeTime = Math.min(lifeTime, size);
        size = pathFromOpponent2 == null ? Integer.MAX_VALUE : eta[2];
        this.lifeTime = Math.min(lifeTime, size);
    }
    
    public void validateDeathSpeed(){
        PathFinder p = strategy.getPathfinder();       
        int min = 0;
        for(int i=0; i<3; i++){
            if(eta[i] < eta[min]) min = i;
        }
        float dif = oldeta[min] - eta[min];
        
        deathSpeed = Math.min(1, Math.max(-1, deathSpeed+(dif/6f)+(dif==0f?-1.0f/6.0f:0) ));
        
        
    }
    
    public void setLifeTime(int value){
        this.lifeTime=value;
    }
    
    public void setDeathSpeed(int value){
        this.deathSpeed=value;
    }
    
    public int getLifeTime(){
        return lifeTime;
    }
    
    public int getValue(){
        return value;
    }
    
    public float getDeathSpeed() {
        return deathSpeed;
    }
    
    public boolean equals(Object o){
        if(!(o instanceof VirtualTreasure)){
            return false;
        }
        VirtualTreasure p = (VirtualTreasure) o;
        if(p.getX() == this.getX() && p.getY() == this.getY()){
            return true;
        }
        return false;
    }
    
    public Object clone(){
        
        VirtualTreasure newTreasure = new VirtualTreasure(this.getX(), this.getY(), this.value, this.strategy);
        newTreasure.lifeTime = this.lifeTime;
        newTreasure.deathSpeed = this.deathSpeed;
        newTreasure.eta = this.eta;
        newTreasure.oldeta = this.oldeta;
        if(this.pathFromPlayer != null){
            newTreasure.pathFromPlayer = (ArrayList<Position>) this.pathFromPlayer.clone();
        }
        if(this.pathFromOpponent0 != null){
            newTreasure.pathFromOpponent0 = (ArrayList<Position>) this.pathFromOpponent0.clone();
        }
        if(this.pathFromOpponent1 != null){
            newTreasure.pathFromOpponent1 = (ArrayList<Position>) this.pathFromOpponent1.clone();
        }
        if(this.pathFromOpponent2 != null){
            newTreasure.pathFromOpponent2 = (ArrayList<Position>) this.pathFromOpponent2.clone();
        }
        
        return newTreasure;
    }
    public String toString(){
        return "val: "+value+" "+super.toString();
    }
}
