/*
 * HIC.java
 *
 * Created on 20. duben 2006, 12:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.hamsterinside;

import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.Print;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.BatteryTaker;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.Rater;

import java.util.Map;
import java.util.HashMap;
/**
 *
 * @author bobo
 */
public class HIC extends TuringHamster{
    
    private class BT implements BatteryTaker {
        public boolean shallRecharge(LayerItem li) {
            return (li.getEnergy() - 1 + world.getRestRobotEnergy() < world.getMaxRobotEnergy());
        }
    }
    
    private class RT implements Rater {
        public void rate(LayerItem start, LayerItem li) {
            if (start != null) {
                start.price+= li.price / li.getSteps();
                LayerItem si = li.inLayer(robotLayer).getStart();
                if (! si.samePos(robot)) {
                    start.price/= 2;
                } else {
                }
            }
        }
    }
    
    private BT bt;
    private RT rt;
    
    private Map<Direction, Layer> dirLayers;
    private Layer robotLayer;
    private Layer tmpLayer;
    private Map<Direction, Integer> dirPrices;
    
    /** Creates a new instance of HIC */
    public HIC() {
    }
    
    public void initialize() {
        super.initialize();
        bt = new BT();
        hi.setBatteryTaker(bt);
        rt = new RT();
        hi.setRater(rt);
        dirLayers = new HashMap<Direction, Layer>();
        for (Direction dir: Direction.values()) {
            dirLayers.put(dir, hi.addLayer());
        }
        robotLayer = hi.addLayer();
        tmpLayer = hi.addLayer();
        dirPrices = new HashMap<Direction, Integer>();
    }
    
    protected BotAction hi() {
        LayerItem li, di;

        if (mustRest()) return BotAction.REST;
        
        if (containsBattery()) {
            if (robot.getEnergy() - 1 + world.getRestRobotEnergy() < world.getMaxRobotEnergy()) {
                return BotAction.RECHARGE;
            }
        }
        hi.clear();
        
        // tadyhle si to rozpocita ve vedlejsi vrstve ty ctyri policka, tak aby tam byla
        // akorat enegie pocet tahu a tak
        tmpLayer.assignRobot(robot);
        hi.setRules(RULE_GRAIN | RULE_WALL);
        hi.findWays(6, tmpLayer.get(robot));
        //no a ted postupne do jednotlivych vrstev zkopiruje udaje na prislusne pole
        for (Direction d: Direction.values()) {
            li = tmpLayer.get(robot).getNeighbour(d);
            if ((li != null) && (li.getSteps() < Integer.MAX_VALUE)) {
                di = li.inLayer(dirLayers.get(d));
                di.weakAssign(li);
                hi.addStart(di);
            }
        }
        // a spusti opravdove hledani
        hi.setRules(RULE_GRAIN | RULE_WALL | RULE_ENERGY | RULE_PASBATTERY | RULE_ACTBATTERY | RULE_ROBOTS);
        hi.findWays(remainRounds());
        //ted pripravi vrstvu s roboty
        for (Robot r: roboti) {
            robotLayer.assignRobot(r);
            hi.addStart(robotLayer.get(r));
        }
        // a spusti opravdove hledani dalsi
        hi.setRules(RULE_WALL | RULE_ROBOTS | RULE_GRAIN);
        hi.findWays(remainRounds());
        
    //    hi.printLayer(dirLayers.get(Direction.UP), Print.STEPS);
        
        // a zacne hodnotit
        for (Direction d: Direction.values()) {
            Layer l = dirLayers.get(d);
            if (!l.getStarts().isEmpty()) {
                for (Grain g: grain) {
                    hi.rateFrom(l.get(g), g.value * 100);
                }
            }
        }
        
        for (Robot r: roboti) {
            robotLayer.assignRobot(r);
            hi.addStart(robotLayer.get(r));
        }
        hi.setRules(RULE_WALL | RULE_ROBOTS);
        hi.findWays(remainRounds());
        
        for (Direction d: Direction.values()) {
            if (!dirLayers.get(d).getStarts().isEmpty()) {
                li = dirLayers.get(d).getStarts().get(0);
                dirPrices.put(d, li.price);
            } else dirPrices.put(d, 0);
        }
        actionsPrices.put(BotAction.STEP, dirPrices.get(Direction.UP));
        actionsPrices.put(BotAction.LEFT, dirPrices.get(Direction.LEFT));
        actionsPrices.put(BotAction.RIGHT, dirPrices.get(Direction.RIGHT));
        if (dirPrices.get(Direction.DOWN) > dirPrices.get(Direction.LEFT)) {
            actionsPrices.put(BotAction.LEFT, dirPrices.get(Direction.DOWN));
        }
        if (dirPrices.get(Direction.DOWN) > dirPrices.get(Direction.RIGHT)) {
            actionsPrices.put(BotAction.RIGHT, dirPrices.get(Direction.DOWN));
        }
        if (containsTreasure()) {
            actionsPrices.put(BotAction.TAKE, getTreasureValue() * 100);
        }
        return resolveBestAction();
    }
}
