/*
 * HamsterInside.java
 *
 * Created on 17. duben 2006, 21:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.hamsterinside;

import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.Print;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.BatteryTaker;
import cz.muni.fi.fibot.hamsterinside.HamsterficialIntelligence.Rater;

import java.util.Map;
import java.util.HashMap;
import java.util.List;
/**
 *
 * @author bobo
 */
public class HamsterInside extends HIC {
    
    // zatim tak, predpokladam, ze po mne nikdo nebude strilet
    private class BT implements BatteryTaker {
        public boolean shallRecharge(LayerItem li) {
            return ( (li.getEnergy() * 2 < world.getMaxRobotEnergy()) &&
                    (world.getMaxRobotEnergy() - li.getEnergy() > world.getRestRobotEnergy()) );
        }
    }
    
    private class RT implements Rater {
        public void rate(LayerItem start, LayerItem li) {
            boolean vic = false, krecek = false;
            int hodnoceni = li.price / (2 * li.getSteps());
            if (start != null) {
                LayerItem si = li.inLayer(robotLayer).getStart();
                while (si != null) { // policko ma nejaky start
                    if (! si.samePos(robot)) { // neni to krecek
                        vic = true;
                    } else { krecek = true; }
                    si = si.getAlternative();
                }
                // tri moznosti hodnoceni
                if (krecek) {
                    if (!vic) { start.price += hodnoceni; } else { start.price += hodnoceni/2; }
                } else { start.price += hodnoceni/20; } // skoro nebrat v potaz
            }
        }
    }
    
    private BT bt;
    private RT rt;
    
    private Map<Direction, Layer> dirLayers;
    private Layer robotLayer;
    private Layer tmpLayer;
    private Map<Direction, Integer> dirPrices;
    
    private int k_pole = 10000, k_prohled = 3000;
    // konstanty, kteryma se budou nasobit hodnoty poli pri posuzovani akce a pri prohledavani
    
    /** Creates a new instance of HamsterInside */
    public HamsterInside() {
    }
    
    public void initialize() {
        super.initialize();
        bt = new BT();
        hi.setBatteryTaker(bt);
        rt = new RT();
        hi.setRater(rt);
        dirLayers = new HashMap<Direction, Layer>();
        for (Direction dir: Direction.values()) {
            dirLayers.put(dir, hi.addLayer());
        }
        robotLayer = hi.addLayer();
        tmpLayer = hi.addLayer();
        dirPrices = new HashMap<Direction, Integer>();
    }
    
    protected BotAction hi() {
        LayerItem li, di;
        int poklady=0; // soucet hodnot pokladu
        for (Grain g: grain) { poklady += g.value; }
        
        if (mustRest()) {
            if (containsBattery()) return BotAction.RECHARGE;
            else return BotAction.REST;
        }
        
        if (containsBattery()) { // pole musi byt bezpecne
            if ( (robot.getEnergy() * 2 < world.getMaxRobotEnergy()) &&
                    (world.getMaxRobotEnergy() - robot.getEnergy() > world.getRestRobotEnergy()) &&
                    dangers.isEmpty() && possibleDangers.isEmpty() && attackers.isEmpty() && targets.get(Direction.UP).isEmpty() ) {
                return BotAction.RECHARGE;
            } // nebo musi mit uz malo energie
            if ( (robot.getEnergy() * 5 < world.getMaxRobotEnergy()) &&
                    (world.getMaxRobotEnergy() - robot.getEnergy() > world.getRestRobotEnergy()) ) {
                return BotAction.RECHARGE;
            } // nebo musi byt posledni kolo, pak ohodnotit bodovy zisk
            if (isLastRound()) {
                actionsPrices.put(BotAction.RECHARGE, (world.getMaxRobotEnergy() - robot.getEnergy()) * k_pole);
            }
        }
        hi.clear();
        
        // tadyhle si to rozpocita ve vedlejsi vrstve ty ctyri policka, tak aby tam byla
        // akorat energie, pocet tahu a tak
        tmpLayer.assignRobot(robot);
        hi.setRules(RULE_GRAIN | RULE_WALL | RULE_ENERGY);
        hi.findWays(6, tmpLayer.get(robot));
        // no a ted postupne do jednotlivych vrstev zkopiruje udaje na prislusne pole
        for (Direction d: Direction.values()) {
            li = tmpLayer.get(robot).getNeighbour(d);
            if ((li != null) && (li.getSteps() < Integer.MAX_VALUE)) {
                di = li.inLayer(dirLayers.get(d));
                di.weakAssign(li);
                hi.addStart(di);
            }
        }
        // a spusti opravdove hledani - ohodnocovani
        hi.setRules(RULE_GRAIN | RULE_WALL | RULE_ENERGY | RULE_ACTBATTERY | RULE_PASBATTERY | RULE_ROBOTS);
        hi.findWays(remainRounds());
        // ted pripravi vrstvu s roboty
        for (Robot r: roboti) {
            robotLayer.assignRobot(r);
            hi.addStart(robotLayer.get(r));
        }
        // a spusti opravdove hledani dalsi - ktery robot se na policko dostane jako prvni
        hi.setRules(RULE_GRAIN | RULE_WALL | RULE_ROBOTS);
        hi.findWays(remainRounds());
        
//*****************************************************************************************
        //    hi.printLayer(dirLayers.get(Direction.UP), Print.STEPS);
        
        // a zacne hodnotit
        for (Direction d: Direction.values()) {
            dirPrices.put(d, -1);
        }
        if (!grain.isEmpty()) {
            for (Direction d: Direction.values()) {
                Layer l = dirLayers.get(d);
                if (!l.getStarts().isEmpty()) {
                    // - podle zrni
                    hi.setRater(rt);
                    for (Grain g: grain) {
                        hi.rateFrom(l.get(g), g.value * k_prohled);
                    }
                    li = dirLayers.get(d).getStarts().get(0);
                    dirPrices.put(d, li.price);
                } else { dirPrices.put(d, -1); }
            }
        } else if (targets.get(Direction.UP).isEmpty())  {
            if ((scanUp(1) & POLE_HARD) == 0) {
                dirPrices.put(Direction.UP, 1);
            } else {
                if ((scanLeft(1) & POLE_HARD) == 0) {
                    dirPrices.put(Direction.LEFT, 1);
                }
                if ((scanRight(1) & POLE_HARD) == 0) {
                    dirPrices.put(Direction.RIGHT, 1);
                }
                if ((scanLeft(1) & scanRight(1) & POLE_HARD) != 0) {
                    dirPrices.put(Direction.DOWN, 1);
                }
            }
        }
        
        
        // prinos strelby v aktualnim okamziku
        List<Robot> actual_targets = targets.get(Direction.UP);
        if (actual_targets.isEmpty()) {
            actionsPrices.put(BotAction.SHOOT, -1);
        } else { // je tam nejaky cil
            int hodnoceni = k_pole * (actual_targets.get(0).getEnergy() / 2);
            actionsPrices.put(BotAction.SHOOT, hodnoceni);
        }
        
        // otoceni se za strelbou
        for (Direction d: Direction.values()) {
            actual_targets = targets.get(d);
            if (! actual_targets.isEmpty()) { // je tam cil
                int pom = dirPrices.get(d) + k_pole * (actual_targets.get(0).getEnergy() / 5);
                dirPrices.put(d, pom);
            }
        }
        
        List<Robot> left_targets = targets.get(Direction.LEFT);
        if (left_targets.isEmpty()) {
        } else { // je tam nejaky cil
            //   dirPrices.put(, li.price);
        }
        
        // prinos sezrani zrni v aktualnim okamziku
        if (containsTreasure()) {
            actionsPrices.put(BotAction.TAKE, getTreasureValue() * k_pole);
        }
        
        // prinos odpocivani, pokud je posledni tah
        if (isLastRound() && (!containsBattery())) {
            if ( (world.getMaxRobotEnergy() - robot.getEnergy()) > world.getRestRobotEnergy() ) {
                actionsPrices.put(BotAction.REST, world.getRestRobotEnergy() * k_pole);
            } else {
                actionsPrices.put(BotAction.REST, (world.getMaxRobotEnergy() - robot.getEnergy()) * k_pole);
            }
        }
        
        // prinos smerovych operaci
        actionsPrices.put(BotAction.STEP, dirPrices.get(Direction.UP));
        actionsPrices.put(BotAction.LEFT, dirPrices.get(Direction.LEFT));
        actionsPrices.put(BotAction.RIGHT, dirPrices.get(Direction.RIGHT));
        
        // kdyz je maximum v DOWNu, hod ho na vetsi ze dvou stran
        if ( dirPrices.get(Direction.DOWN) > dirPrices.get(Direction.UP) &&
                dirPrices.get(Direction.DOWN) > dirPrices.get(Direction.LEFT) &&
                dirPrices.get(Direction.DOWN) > dirPrices.get(Direction.RIGHT) ) {
            
            if (dirPrices.get(Direction.RIGHT) > dirPrices.get(Direction.LEFT)) {
                actionsPrices.put(BotAction.RIGHT, dirPrices.get(Direction.DOWN));
            } else if (dirPrices.get(Direction.LEFT) > dirPrices.get(Direction.RIGHT)) {
                actionsPrices.put(BotAction.LEFT, dirPrices.get(Direction.DOWN));
            } else {
                actionsPrices.put(BotAction.RIGHT, dirPrices.get(Direction.DOWN));
                actionsPrices.put(BotAction.LEFT, dirPrices.get(Direction.DOWN));
            }
        }
        return resolveBestAction();
    }
}
