/*
 * Vector.java
 *
 * Created on 19. duben 2006, 20:51
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.hamsterinside;

import cz.muni.fi.fibot.Robot.Direction;

/**
 * Vector, td pro jednodu manipulaci s vektory - smry.
 * @author bobo
 */
public class Vector {
    public int x, y;
    
    /** Creates a new instance of Vector */
    public Vector(int nX, int nY) {
        x = nX; y = nY;
    }
    public Vector(Vector v) {
        x = v.x; y = v.y;
    }
    public Vector(Direction dir) {
        setDirection(dir);
    }
    /**
     * Oto vektor vlevo
     */
    public void turnLeft() {
        int t = x;
        x = y;
        y = -t;
    }
    /**
     * Oto vektor vpravo
     */
    public void turnRight() {
        int t = x;
        x = -y;
        y = t;
    }
    /**
     * Obrt vektor nazptek
     */
    public void turnBack() {
        x = -x;
        y = -y;
    }
    /**
     * Nastav vektor podle zadanho smru
     */
    public void setDirection(Direction dir) {
        switch (dir) {
            case DOWN: setDir(0, 1); break;
            case LEFT: setDir(-1, 0); break;
            case RIGHT: setDir(1, 0); break;
            case UP: setDir(0, -1); break;
        }
    }
    /**
     * Oto vektor podle zadanho smru
     */
    public void applyDirection(Direction dir) {
        switch (dir) {
            case DOWN: turnBack(); break;
            case LEFT: turnLeft(); break;
            case RIGHT: turnRight(); break;
        }
    }
    /**
     * Oto vektor pdole zadanho smru (0 - 3). Odpovdaj hodnotm Directio.LEFT - Direction.DOWN
     */
    public void applyDirection(int dir) {
        switch (dir) {
            case 0: turnLeft(); break;
            case 2: turnRight(); break;
            case 3: turnBack(); break;
        }
    }
    public void setDir(int nX, int nY) {
        x = nX; y = nY;
    }
    public void setDir(Vector value) {
        x = value.x; y = value.y;
    }
    
}
