/*
 * Tento soubor obsahuje trudu Reachability
 */

package cz.muni.fi.fibot.hrobot;


import java.util.LinkedList;
import java.util.Queue;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.World;
import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.hrobot.Coords;
import cz.muni.fi.fibot.hrobot.CoordsAndDirection;
import cz.muni.fi.fibot.hrobot.CoordsAndValue;

/**
 * Trida pro ochovani vydleku reachability na World
 */
public interface Reachability {       
    public int get_from_x();
    public int get_from_y();
    
    public void set_battery_distance(int index, int d);
    public void set_battery_direction(int index, int d);
    public void set_battery_movement(int index, Strategy.BotAction m);
    public int get_battery_distance(int index);
    public int get_battery_direction(int index);
    public Strategy.BotAction get_battery_movement(int index);
    public int get_battery_count();
    
    public void set_treasure_distance(int index, int d);
    public void set_treasure_direction(int index, int d);
    public void set_treasure_movement(int index, Strategy.BotAction m);
    public int get_treasure_distance(int index);
    public int get_treasure_direction(int index);
    public Strategy.BotAction get_treasure_movement(int index);
    public int get_treasure_count();
   
    public void set_robot_distance(int index, int d);
    public void set_robot_direction(int index, int d);
    public void set_robot_movement(int index, Strategy.BotAction m);
    public int get_robot_distance(int index);
    public int get_robot_direction(int index);
    public Strategy.BotAction get_robot_movement(int index);
    public int get_robot_count();
    
    public int get_distance(int x, int y, int direction);
    
    public Strategy.BotAction get_first_action(int x, int y, int direction);
    public void reachability_from(int x, int y, int direction, int bound);

    public void reachability_from_robot(Robot r, int bound);
}

