/*
 * RestTactic.java
 *
 * Created on 21. květen 2006, 19:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.hrobot;

import cz.muni.fi.fibot.hrobot.Tactic;
import cz.muni.fi.fibot.hrobot.HrobotCommon;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.World;
 

/**
 *
 * @author p
 */
public class RestTactic implements Tactic {
    
    private HrobotCommon common;
    private Robot robot;
    private World world;
    private int normalized_profit;
    private Strategy.BotAction first_action;
    
    /** Creates a new instance of RestTactic */
    public RestTactic() {
        normalized_profit = 0;
        first_action = Strategy.BotAction.NOTHING;
    }
    
    public void setHrobotCommon(HrobotCommon common_arg)
    {
        common = common_arg;
        robot = common_arg.get_robot();
        world = common_arg.get_world();
    }

    public void execute()
    {
        boolean[] from_direction = new boolean[4];
        int gain = 0;
        
        if (common.get_remaining_rounds()==1)
        {
            if (world.containsBattery(robot.getPositionX(), robot.getPositionY()))
            {
                first_action = Strategy.BotAction.RECHARGE;
                gain = world.getMaxRobotEnergy() - robot.getEnergy();
            }
            else
            {
                first_action = Strategy.BotAction.REST;
                gain = world.getRestRobotEnergy();
                if (gain>world.getMaxRobotEnergy()-robot.getEnergy()) gain = world.getMaxRobotEnergy()-robot.getEnergy();
            }
        }
        else
            if (common.get_remaining_rounds() <= world.getMaxRobotEnergy()/world.getRestRobotEnergy())
            {
                if (!common.under_attack(robot.getPositionX(), robot.getPositionY(), from_direction)
                    &&
                    !common.future_under_attack(robot.getPositionX(), robot.getPositionY(), from_direction))
                {
                    first_action = Strategy.BotAction.REST;
                    gain = common.get_remaining_rounds()*world.getRestRobotEnergy();
                }
            }
        
        normalized_profit = gain*1024/common.get_remaining_rounds();
        
        
    }
        
        
    public Strategy.BotAction getNextAction()
    {
        return first_action;
    }
    
    
    public int getNormalizedProfit()
    {
        return normalized_profit;
    }
    
}
