/*
 * Karel.java
 *
 * Created on 4. duben 2006, 15:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.karel;

import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.World;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Ladislav Chodil, Jakub urovec
 */
public class Karel implements Strategy {

  private Robot robot;
  private World world;
  private static KarelWorld karelWord;

  public Karel() {
  }

  public void setWorld(World world) {
    this.world = world;
  }

  public void setRobot(Robot robot) {
    this.robot = robot;
  }
  
  private boolean stojimNaBaterce() {
    return world.containsBattery(x(), y());
  }
  
  private boolean stojimNaPokladu() {
    return world.containsTreasure(x(), y());
  }  
  
  private int cenaPokladuKdeStojim() {
      if (world.containsTreasure(x(), y())) return world.getTreasureValue(x(), y());
      return 0;
  }  
  

  public BotAction decide() {
    // zchrana ivota
    if (robot.getEnergy() <= 1) {
      if (stojimNaBaterce()) return BotAction.RECHARGE;
      return BotAction.REST;
    }
    
    // strelba?
    int shoot = karelWord.shootValue(x(), y(), d());
        
    // strilime vdycky kdyz se neco nachomitne
    if (shoot > 1) return BotAction.SHOOT;
        
    if (stojimNaPokladu()) return BotAction.TAKE;        
    
    // rozhodnut, kam jt
    float vlevo=0, vpravo=0, krok=0;
    // projt vechny poklady
    List<Point> poklady = karelWord.getPoklady();
    Point rp = new Point(robot.getPositionX(), robot.getPositionY());
    
    for (int i = 0; i < poklady.size(); i++) {
      Point poklad = poklady.get(i);
      int hodnota = world.getTreasureValue(poklad.x, poklad.y);
      int vzdalenost = karelWord.getVzdalenost(rp.x, rp.y, poklad.x, poklad.y);
      // kontrola na nulu, nedosaiteln pole
      if (vzdalenost <= 0) vzdalenost = Integer.MAX_VALUE;
      int koeficient = (int)(vzdalenost/2);
      
      List<Point3D> path = karelWord.getPath(rp.x, rp.y, poklad.x, poklad.y);
      int vychPozice = path.get(path.size() - 1).z;
      // rozhodnut, kam pjdeme
      switch (vychPozice) {
        case KarelWorld.EAST:
          switch (robot.getDirection()) {
            case UP:
              vlevo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case LEFT:
              krok += (float)hodnota / (float)(vzdalenost * koeficient); break;
            case DOWN:
              vpravo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case RIGHT:
              vlevo += (float)hodnota / (float)((vzdalenost + 2) * koeficient); 
          }
          break;
        case KarelWorld.SOUTH:
          switch (robot.getDirection()) {
            case UP:
              krok += (float)hodnota / (float)(vzdalenost * koeficient); break;
            case LEFT:
              vpravo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case DOWN:
              vlevo += (float)hodnota / (float)((vzdalenost + 2) * koeficient); break;
            case RIGHT:
              vlevo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); 
          }
          break;
        case KarelWorld.WEST:
          switch (robot.getDirection()) {
            case UP:
              vpravo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case LEFT:
              vpravo += (float)hodnota / (float)((vzdalenost + 2) * koeficient); break;
            case DOWN:
              vlevo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case RIGHT:
              krok += (float)hodnota / (float)(vzdalenost * koeficient); 
          }
          break;
        case KarelWorld.NORTH:
          switch (robot.getDirection()) {
            case UP:
              vpravo += (float)hodnota / (float)((vzdalenost + 2) * koeficient); break;
            case LEFT:
              vlevo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); break;
            case DOWN:
              krok += (float)hodnota / (float)(vzdalenost * koeficient); break;
            case RIGHT:
              vpravo += (float)hodnota / (float)((vzdalenost + 1) * koeficient); 
          }
      }
    }
    if (krok > vpravo)
      if (krok > vlevo) return BotAction.STEP;
      else return BotAction.LEFT;
    else
      if (vpravo > vlevo) return BotAction.RIGHT;
      else return BotAction.LEFT;   
  }

  public void initialize() {
    if (karelWord == null)
      this.karelWord = new KarelWorld(world);
  }
  
  private int x(){
    return robot.getPositionX();
  }
  
  private int y(){
    return robot.getPositionY();  
  }
  
  private Robot.Direction d(){
    return robot.getDirection();  
  }
   
}
