package cz.muni.fi.fibot.number5;

import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.number5.Number5Square.SquareType;
import java.util.LinkedList;

public class Number5Preprocessor {
    
    protected Number5 core = null;
    
    /**
     * kostruktor
     * @param core - jadro robota, pres ktere pracuje
     */
    protected Number5Preprocessor(Number5 core){
        this.core = core;
    }
    
    /**
     * - samotna prace - volane na zacatku kazdeho kola (pote co se zavola metoda step() vsech robotu)
     * - vysledky zapise do core.gameMap
     */
    protected void preprocess(){
        for(int iy=0; iy<core.gameMap[0].length; iy++)
            for (int ix=0; ix<core.gameMap.length; ix++)
                core.gameMap[ix][iy].minimum.erase();
                
        for(int i=0; i<core.robots.length; i++) {
            preprocessRobot(i);
            //printoutDataRobot(i);
        }
    }
    
    protected void preprocessSpecial(){
        for(int i=0; i<core.special.length; i++) {
            preprocessSpecial(i);
            //printoutDataRobot(i);
        }
    }
    
    protected void printoutDataRobot(int index) {
        System.out.println("Format: Top Right Down Left Shot |");
        for(int iy=0; iy<core.gameMap[0].length; iy++) {
            for (int ix=0; ix<core.gameMap.length; ix++) {
                String s = core.gameMap[ix][iy].robots[index].toString();
                for(int j=s.length(); j<14; j++) {
                    s += " ";
                }
                System.out.print(s+"|");
            }
            System.out.println();
        }
    }
    
    protected void preprocessRobot(int index){
        int x = core.robots[index].state.positionX;
        int y = core.robots[index].state.positionY;
        
        boolean me = (core.robots[index] == core.me);
        
        //vycisteni dat jednoho robota
        for(int ix=0; ix<core.gameMap.length; ix++) {
            for (int iy=0; iy<core.gameMap[0].length; iy++) {
                core.gameMap[ix][iy].robots[index].erase();
            }
        }
        
        // nastaveni korene prochazeni do sirky
        if (core.robots[index].state.direction == Direction.UP)
            core.gameMap[x][y].robots[index].stepsToStandTop=0;
        if (core.robots[index].state.direction == Direction.DOWN)
            core.gameMap[x][y].robots[index].stepsToStandDown=0;
        if (core.robots[index].state.direction == Direction.LEFT)
            core.gameMap[x][y].robots[index].stepsToStandLeft=0;
        if (core.robots[index].state.direction == Direction.RIGHT)
            core.gameMap[x][y].robots[index].stepsToStandRight=0;
        
        core.gameMap[x][y].robots[index].fillotherdirections(me ? null : core.gameMap[x][y].minimum);
        
        // vytvoreni fronty a vlozeni korene
        LinkedList<Number5Square> queue = new LinkedList<Number5Square>();
        queue.add(core.gameMap[x][y]);
        
        while (!queue.isEmpty()) {
                /*for (int i=0; i<queue.size(); i++) {
                                        String s = Integer.toString(queue.get(i).x)+" "+Integer.toString(queue.get(i).y)+"|";
                                        System.out.print(s);
                                }
                                        System.out.println("");*/
            
            
            Number5Square p = null;
            Number5Square root = queue.poll();
            
            fillstepsToShot(root, index);
            
            if (root.x+1 < core.gameMap.length
                    && (p = core.gameMap[root.x+1][root.y]).type != SquareType.WALL
                    && (root.robots[index].stepsToStandRight + 1 < p.robots[index].stepsToStandRight
                    || p.robots[index].stepsToStandRight == -1)
                    ){
                p.robots[index].stepsToStandRight = root.robots[index].stepsToStandRight + 1;
                p.robots[index].fillotherdirections(me ? null : p.minimum);
                queue.add(p);
            }
            if (root.x-1 >= 0
                    && (p = core.gameMap[root.x-1][root.y]).type != SquareType.WALL
                    && (root.robots[index].stepsToStandLeft + 1 < p.robots[index].stepsToStandLeft
                    || p.robots[index].stepsToStandLeft == -1)
                    ){
                p.robots[index].stepsToStandLeft = root.robots[index].stepsToStandLeft + 1;
                p.robots[index].fillotherdirections(me ? null : p.minimum);
                queue.add(p);
            }
            if (root.y+1 < core.gameMap[0].length
                    && (p = core.gameMap[root.x][root.y+1]).type != SquareType.WALL
                    && (root.robots[index].stepsToStandDown + 1 < p.robots[index].stepsToStandDown
                    || p.robots[index].stepsToStandDown == -1)
                    ){
                p.robots[index].stepsToStandDown = root.robots[index].stepsToStandDown + 1;
                p.robots[index].fillotherdirections(me ? null : p.minimum);
                queue.add(p);
            }
            if (root.y-1 >= 0
                    && (p = core.gameMap[root.x][root.y-1]).type != SquareType.WALL
                    && (root.robots[index].stepsToStandTop + 1 < p.robots[index].stepsToStandTop
                    || p.robots[index].stepsToStandTop == -1)
                    ){
                p.robots[index].stepsToStandTop = root.robots[index].stepsToStandTop + 1;
                p.robots[index].fillotherdirections(me ? null : p.minimum);
                queue.add(p);
            }
        }
    }
    
    protected void preprocessSpecial(int index){
        int x = core.special[index].x;
        int y = core.special[index].y;
        
        //vycisteni dat jednoho robota
        for(int ix=0; ix<core.gameMap.length; ix++) {
            for (int iy=0; iy<core.gameMap[0].length; iy++) {
                core.gameMap[ix][iy].special[index].erase();
            }
        }
        
        // ze vsech stran dame nulu, protoze se neda tusit z jake strany tam prijdeme
        
        core.gameMap[x][y].special[index].stepsToStandTop=0;
        core.gameMap[x][y].special[index].stepsToStandDown=0;
        core.gameMap[x][y].special[index].stepsToStandLeft=0;
        core.gameMap[x][y].special[index].stepsToStandRight=0;
        
        // vytvoreni fronty a vlozeni korene
        LinkedList<Number5Square> queue = new LinkedList<Number5Square>();
        queue.add(core.gameMap[x][y]);
        
        while (!queue.isEmpty()) {
                /*for (int i=0; i<queue.size(); i++) {
                                        String s = Integer.toString(queue.get(i).x)+" "+Integer.toString(queue.get(i).y)+"|";
                                        System.out.print(s);
                                }
                                        System.out.println("");*/
            
            
            Number5Square p = null;
            Number5Square root = queue.poll();
            
            if (root.x+1 < core.gameMap.length
                    && (p = core.gameMap[root.x+1][root.y]).type != SquareType.WALL
                    && (root.special[index].stepsToStandRight + 1 < p.special[index].stepsToStandRight
                    || p.special[index].stepsToStandRight == -1)
                    ){
                p.special[index].stepsToStandRight = root.special[index].stepsToStandRight + 1;
                p.special[index].fillotherdirections(null);
                queue.add(p);
            }
            if (root.x-1 >= 0
                    && (p = core.gameMap[root.x-1][root.y]).type != SquareType.WALL
                    && (root.special[index].stepsToStandLeft + 1 < p.special[index].stepsToStandLeft
                    || p.special[index].stepsToStandLeft == -1)
                    ){
                p.special[index].stepsToStandLeft = root.special[index].stepsToStandLeft + 1;
                p.special[index].fillotherdirections(null);
                queue.add(p);
            }
            if (root.y+1 < core.gameMap[0].length
                    && (p = core.gameMap[root.x][root.y+1]).type != SquareType.WALL
                    && (root.special[index].stepsToStandDown + 1 < p.special[index].stepsToStandDown
                    || p.special[index].stepsToStandDown == -1)
                    ){
                p.special[index].stepsToStandDown = root.special[index].stepsToStandDown + 1;
                p.special[index].fillotherdirections(null);
                queue.add(p);
            }
            if (root.y-1 >= 0
                    && (p = core.gameMap[root.x][root.y-1]).type != SquareType.WALL
                    && (root.special[index].stepsToStandTop + 1 < p.special[index].stepsToStandTop
                    || p.special[index].stepsToStandTop == -1)
                    ){
                p.special[index].stepsToStandTop = root.special[index].stepsToStandTop + 1;
                p.special[index].fillotherdirections(null);
                queue.add(p);
            }
        }
    }
    
    /**
     *
     */
    protected void fillstepsToShot(Number5Square a, int index){
        int i=1;
        Number5Square p = null;
        while (a.x+i < core.gameMap.length
                && (p=core.gameMap[a.x+i][a.y]).type != SquareType.WALL) {
            if (p.robots[index].stepsToShoot > a.robots[index].stepsToStandRight + 1
                    || p.robots[index].stepsToShoot == -1) {
                p.robots[index].stepsToShoot = a.robots[index].stepsToStandRight + 1;
                p.robots[index].shootPosition = a;
                p.robots[index].shootDirection = Direction.RIGHT;
            }
            i++;
        }
        i=1;
        while (a.x-i >= 0
                && (p=core.gameMap[a.x-i][a.y]).type != SquareType.WALL) {
            if (p.robots[index].stepsToShoot > a.robots[index].stepsToStandLeft + 1
                    || p.robots[index].stepsToShoot == -1) {
                p.robots[index].stepsToShoot = a.robots[index].stepsToStandLeft + 1;
                p.robots[index].shootPosition = a;
                p.robots[index].shootDirection = Direction.LEFT;
            }
            i++;
        }
        i=1;
        while (a.y+i < core.gameMap[0].length
                && (p=core.gameMap[a.x][a.y+1]).type != SquareType.WALL) {
            if (p.robots[index].stepsToShoot > a.robots[index].stepsToStandDown + 1
                    || p.robots[index].stepsToShoot == -1) {
                p.robots[index].stepsToShoot = a.robots[index].stepsToStandDown + 1;
                p.robots[index].shootPosition = a;
                p.robots[index].shootDirection = Direction.DOWN;
            }
            i++;
        }
        i=1;
        while (a.y-i >= 0
                && (p=core.gameMap[a.x][a.y-i]).type != SquareType.WALL) {
            if (p.robots[index].stepsToShoot > a.robots[index].stepsToStandTop + 1
                    || p.robots[index].stepsToShoot == -1) {
                p.robots[index].stepsToShoot = a.robots[index].stepsToStandTop + 1;
                p.robots[index].shootPosition = a;
                p.robots[index].shootDirection = Direction.UP;
            }
            i++;
        }
        i=1;
        
        // aktualizuje minimum (pokud robots[index] nejsem ja)
        if(core.robots[index] != core.me && a.minimum.stepsToShoot > p.robots[index].stepsToShoot) a.minimum.stepsToShoot = p.robots[index].stepsToShoot;
    }
}
