package cz.muni.fi.fibot.number5;

public class Number5Proposal implements Comparable<Number5Proposal> {
    
    /**
     * potrebny pocet tahu ke splneni cile
     */
    protected int steps;
    /**
     * odhadovany pocet ziskanych bodu (muze byt dost virtualni - strategie si do tohoto cisla muze pocitat, co chce)
     */
    protected int points;
    
    /**
     * priorita navrhu na preruseni
     */
    protected int priority = Number5Run.PRIORITY_NOT_SET;
    
    /**
     * textovy popis navrhu k odladovani
     */
    String description;
    
    /**
     * navrh strategie, ktera se nechce ucastnit voleb
     */
    protected static Number5Proposal NO_PLAN = new Number5Proposal(0, 0, "Nemam zadny plan.");
    
    /**
     * konstruktor pro volebni navrh na ridici strategii
     */
    public Number5Proposal(int steps, int points, String description){
        this.steps = steps;
        this.points = points;
        this.description = description;
    }
    
    /**
     * konstruktor pro volebni navrh na prerusujici strategii
     */
    public Number5Proposal(int steps, int points, int priority, String description){
        this.steps = steps;
        this.points = points;
        this.priority = priority;
        this.description = description;
    }
    
    // kladny vysleked - ja jsem lepsi nez "other"
    public int compareTo(Number5Proposal other){
        // nejprve priorita
        if((priority != Number5Run.PRIORITY_NOT_SET && other.priority != Number5Run.PRIORITY_NOT_SET)
            && priority != other.priority) return priority - other.priority;
        else {
            // osetrit pripad uplne bezcilnych navrhu
            if(steps == 0) return -1;
            else if(other.steps == 0) return 1;
            
            float diff = ((float)points / (float)steps - (float)other.points / (float)other.steps);
            if(diff > 0) return 1;
            else if(diff < 0) return -1;
            
            // jinak ma prioritu kratsi delka navrhu
            else return other.steps - steps;
        }
    }
    
    public String toString(){
        return description + " - " + points + " / " + steps + " = " + ((float)points / (float)steps);
    }
}
