package cz.muni.fi.fibot.number5;

public class Number5Square implements Comparable<Number5Square> {

	public enum SquareType {
		WALL, BATTERY, HALL
	};
	
	/********************************************* SMI UPRAVOVAT POUZE JADRO **********************************************/
	/**
	 * umisteni policka v x souradnici
	 */
	public int x;
	/**
	 * umisteni policka v y souradnici
	 */	
	public int y;
	/**
	 * type policka - nezahrnuje v sobe, zda je tam poklad nebo robot!
	 */	
	public SquareType type;
	/**
	 * poklad na policku - 0 znamena, ze zde neni poklad
	 */	
	public int treasure = 0;
	/**
	 * robot na policku - null znamena, ze zde neni robot
	 */	
	Number5Robot robot = null;
	
	
	/****************************************** SMI UPRAVOVAT POUZE PREDZPRACOVANI ***************************************/
	/**
	 * informace k nasemu robotu (stejny objekt jaky se nachazi v poli robots)
	 * preprocessor tedy nemusi do tohoto objektu zapisovat zvlast
	 */
	protected Number5SquareInfo me;
	
	/**
	 * informace k jednotlivym robotum (pole je stejne indexovane jako core.robots)
	 */
	protected Number5SquareInfo robots[];
        
        protected Number5SquareInfo special[];
	
	/**
	 * - minimum udaju pres informace ke vsem robotum KROME NASEHO
	 * - podstatne, kdyz nekoho zajima napr. za kolik tahu se na policko dostane libovolny robot 
	 * 	-> aby nemusel prochazet cele pole robots 
	 */
	protected Number5SquareInfo minimum;
	
	
	
	public Number5Square(int x, int y, SquareType type, int treasure, int robots, int special, int myIndex){
		this.x = x;
		this.y = y;
		this.type = type;
		this.treasure = treasure;
		
		this.robots = new Number5SquareInfo[robots];
		for(int i = 0; i < robots; i++) this.robots[i] = new Number5SquareInfo();
                
                this.me = this.robots[myIndex];
		this.minimum = new Number5SquareInfo();
                
                this.special = new Number5SquareInfo[special];
                for(int i = 0; i < special; i++) this.special[i] = new Number5SquareInfo();
	}
        
        public String toString(){
            return "["+x+":"+y+", "+type+(treasure > 0 ? " treasure:"+treasure : "")+"]";
        }
        
        public int compareTo(Number5Square b){
            return (me.getMinimumStepsToStand() - b.me.getMinimumStepsToStand());
        }
}

