package cz.muni.fi.fibot.number5;

import cz.muni.fi.fibot.Robot.Direction;

public class Number5SquareInfo {
    // pocet tahu aby objekt stal na tomto policku v prislusnem smeru
    protected int stepsToStandLeft = -1;
    protected int stepsToStandTop = -1;
    protected int stepsToStandRight = -1;
    protected int stepsToStandDown = -1;
    
    // pocet tahu, nez bude moci objekt pres toto policko vystrelit (vcetne tahu na strelbu)
    protected int stepsToShoot = -1;
    // misto, z ktereho je nejvyhodnejsi strilet
    protected Number5Square shootPosition = null;
    // otoceni k nejvyhodnejsi strelbe
    protected Direction shootDirection = Direction.LEFT;
    
    public String toString() {
        return Integer.toString(stepsToStandTop) + " " + Integer.toString(stepsToStandRight) + " "
                + Integer.toString(stepsToStandDown) + " " + Integer.toString(stepsToStandLeft) + " "
                + Integer.toString(stepsToShoot);
    }
    
    public int getMinimumStepsToStand(){
        return getStepsToStand(getBestReachingDirection());
    }
    
    public Direction getBestReachingDirection(){
        Direction min = Direction.LEFT;
        if(stepsToStandTop < getStepsToStand(min)) min = Direction.UP;
        else if(stepsToStandRight < getStepsToStand(min)) min = Direction.RIGHT;
        else if(stepsToStandDown < getStepsToStand(min)) min = Direction.DOWN;
        
        return min;
    }
    
    public int getStepsToStand(Direction d){
        switch(d){
            case LEFT: return stepsToStandLeft;
            case UP: return stepsToStandTop;
            case RIGHT: return stepsToStandRight;
            default: return stepsToStandDown;
        }
    }
    
    //vymaze hodnoty
    protected void erase() {
        stepsToStandDown = stepsToStandLeft = stepsToStandRight =
                stepsToShoot = stepsToStandTop = -1;
    }
    
    /**
     * predpoklada doplneni potrebnych tahu jen na jednom ze 4 smeru, ostatni
     * pak doplni
     */
    protected void fillotherdirections(Number5SquareInfo minimum){
        if (stepsToStandTop != -1) {
            stepsToStandLeft = stepsToStandRight = stepsToStandTop + 1;
            stepsToStandDown = stepsToStandTop + 2;
        } else if (stepsToStandLeft != -1) {
            stepsToStandTop = stepsToStandDown = stepsToStandLeft +1;
            stepsToStandRight = stepsToStandLeft + 2;
        } else if (stepsToStandDown != -1) {
            stepsToStandLeft = stepsToStandRight = stepsToStandDown + 1;
            stepsToStandTop = stepsToStandDown + 2;
        } else if (stepsToStandRight!= -1) {
            stepsToStandTop = stepsToStandDown = stepsToStandRight +1;
            stepsToStandLeft = stepsToStandRight + 2;
        }
        
        // aktualizuj minimum
        if(minimum != null){
            if(minimum.stepsToStandDown == -1 || minimum.stepsToStandDown > stepsToStandDown) minimum.stepsToStandDown = stepsToStandDown;
            if(minimum.stepsToStandTop == -1 || minimum.stepsToStandTop > stepsToStandTop) minimum.stepsToStandTop = stepsToStandTop;
            if(minimum.stepsToStandLeft == -1 || minimum.stepsToStandLeft > stepsToStandLeft) minimum.stepsToStandLeft = stepsToStandLeft;
            if(minimum.stepsToStandRight == -1 || minimum.stepsToStandRight > stepsToStandRight) minimum.stepsToStandRight = stepsToStandRight;
        }
    }
}