package cz.muni.fi.fibot.number5;

import cz.muni.fi.fibot.Strategy;

public interface Number5Strategy {
	
	/**
	 * interface pro jednotlive strategie naseho robota
	*/
	
	/**
	 * je zavolano tesne po konstruktoru, da strategii odkaz na jadro robota
	 * @param core - jadro robota, pres ktere pozdeji strategie komunikuje s okolnim svetem
	*/
	void setCore(Number5 core);
	
	
	/*********************************** VOLEBNI FUNKCE **********************************/
	
	/**
	 * funkce, kterou jadro zavola pri hlavnich volbach
	 * @return plan teto strategie v podobe objektu Number5Proposal - viz jeho popis
	 * 		nesmi byt null, pokud se nechce zapojit do voleb, musi vratit navrh se ziskem 0 bodu
	*/
	Number5Proposal getMainProposal();
	
	/**
	 * funkce, kterou jadro zavola pri volbe preruseni
	 * @param stepsLimit - maximalni pocet kroku na preruseni
         * @param interruptSelf - je true, prave kdyz je u moci tato strategie (tedy predkladany navrh potencialne prerusi sama sebe)
	 * @return plan teto strategie v podobe objektu Number5Proposal - viz jeho popis
	 * 		nesmi byt null, pokud se nechce zapojit do voleb, musi vratit navrh se ziskem 0 bodu
	*/
	Number5Proposal getInterruptProposal(int stepsLimit, boolean interruptSelf);
	
	
	/**************************** FUNKCE PRO STRATEGII U MOCI **************************/
	
	/**
	 * jadro se pta, jake ma strategie plany, tedy jestli se nevzdava moci, jestli se smi prerusit, atd.
	 * podle toho, jak strategie upravi objekt run, po teto funkci muzou probehnout hlavni volby a/nebo volby preruseni  
	 * @param run - objekt, kterym strategie spravuje preruseni, atd.
	*/
	void manage(Number5Run run);
	
	/**
	 * jadro se pta na samotny tah, ktery strategie v tomto kole provede
	 * @return jedna z nadefinovanych akci (LEFT, RIGHT, STEP, SHOOT, TAKE, REST, RECHARGE)
	*/
	Strategy.BotAction decide();
	
	/**************************** FUNKCE PRERUSUJICI STRATEGIE **************************/
	
	/**
	 * dve analogicke funkce, ktere jadro vola, pokud je tato strategie prave PRERUSUJICI STRATEGII
	*/
	void manageInterrupt(Number5Run run);
	Strategy.BotAction decideInterrupt();
}
