package cz.muni.fi.fibot.orgbot;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.World;

public class OrgBot implements Strategy {

    private World world;
    private Robot robot;
    private boolean shoot_now;
    private int d[][];

    public OrgBot() {
	shoot_now = true;
	d = new int[50][50];
    }
    
    public void setWorld(World w) {
	this.world = w;
    }
    
    public void setRobot(Robot r) {
	this.robot = r;
    }

    public void initialize() {
    }

    private void spocitej_d() {
	int i, j;
	boolean change = true;
	for (i=0; i < world.getDimensionX(); i++)
	    for (j=0; j<world.getDimensionY(); j++)
		if (world.containsTreasure(i,j)) d[i][j] = 0; else d[i][j]=1000;
	while (change) {
	    change = false;
	    for (i=0; i < world.getDimensionX(); i++)
		for (j=0; j<world.getDimensionY(); j++) {
		    if (world.containsWall(i,j)) continue;
		    if (i>0 && d[i-1][j]+1 < d[i][j]) { d[i][j] = d[i-1][j] + 1; change = true;}
		    if (i<world.getDimensionX()-1 && d[i+1][j]+1 < d[i][j]) { d[i][j] = d[i+1][j] + 1; ; change = true;}
		    if (j>0 && d[i][j-1]+1 < d[i][j]) { d[i][j] = d[i][j-1] + 1; ; change = true;}
		    if (j <world.getDimensionY()-1 && d[i][j+1]+1 < d[i][j]) { d[i][j] = d[i][j+1] + 1;; change = true;}
		}
	}
// 	for (i=0; i < world.getDimensionX(); i++) {
// 	    for (j=0; j<world.getDimensionY(); j++) {
// 		System.out.print(d[i][j]);
// 		if (d[i][j] <10 ) System.out.print("  ");
// 		else if (d[i][j] <10 ) System.out.print(" ");
// 	    }
// 	    System.out.println();
// 	}
    }
    
    public Strategy.BotAction decide() {
	if (robot.getEnergy() < 3) {
	    return BotAction.REST;
	}
	if (world.containsTreasure(robot.getPositionX(), robot.getPositionY())) {
	    return BotAction.TAKE;
	}
	int min = 1000;
	spocitej_d();	
	int x = robot.getPositionX();
	int y = robot.getPositionY();
	if (x>0 && d[x-1][y] < min) min = d[x-1][y];
	if (x<world.getDimensionX()-1 && d[x+1][y] < min) min = d[x+1][y];
	if (y>0 && d[x][y-1] < min) min = d[x][y-1];
	if (y<world.getDimensionY()-1 && d[x][y+1] < min) min = d[x][y+1];
	if (min == 1000) {
	    if (shoot_now) { shoot_now = false; return BotAction.SHOOT; }
	    shoot_now = true;
	    return BotAction.LEFT;
	}
	    	
	if (x>0 && min == d[x-1][y])
	    if (robot.getDirection() == Robot.Direction.LEFT) return BotAction.STEP; else
		if (robot.getDirection() == Robot.Direction.DOWN) return BotAction.RIGHT; else return BotAction.LEFT;
	if (x <world.getDimensionX()-1 && min == d[x+1][y])
	    if (robot.getDirection() == Robot.Direction.RIGHT) return BotAction.STEP; else
		if (robot.getDirection() == Robot.Direction.UP) return BotAction.RIGHT; else return BotAction.LEFT;
	if (y>0 && min == d[x][y-1])
	    if (robot.getDirection() == Robot.Direction.UP) return BotAction.STEP; else
		if (robot.getDirection() == Robot.Direction.LEFT) return BotAction.RIGHT; else return BotAction.LEFT;
	if (y <world.getDimensionY()-1 && min == d[x][y+1])
	    if (robot.getDirection() == Robot.Direction.DOWN) return BotAction.STEP; else
		if (robot.getDirection() == Robot.Direction.RIGHT) return BotAction.RIGHT; else return BotAction.LEFT;
	return BotAction.REST;
	
    }

}
