/*
 * Tools.java
 *
 * Created on 7. bezen 2006, 20:13
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.pikachu;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.World;
import java.util.ArrayList;
import java.util.List;

/**
 * This is class mostly for suplementary static methods.
 * @author david
 */
public class Tools {
    
    /**
     * Enum of interesting field types
     */
    public enum FieldType {
        TREASURE, ROBOT, BATERY, WALL
    };    
    
    /** having a world - find all treasures and return a list of positions on which they are */
    public static List<Position> findFields(World world, FieldType type) {
        List<Position> list = new ArrayList<Position> ();
        int xSize = world.getDimensionX();
        int ySize = world.getDimensionY();
        boolean contains = false;
        for (int i=0; i< xSize; i++) {
            for (int j=0; j<ySize; j++) {
                switch (type) {
                    case TREASURE: contains = world.containsTreasure(i, j); break;
                    case ROBOT: contains = world.containsRobot(i, j); break;
                    case BATERY: contains = world.containsBattery(i, j); break;
                    case WALL: contains = world.containsWall(i, j); break;
                }
                if (contains)
                    list.add(new Position(i,j));
            }
        }
        return list;
    }
    
    /** Having a list of all robots in the game and "me" robot - calculate the
     * "level of victory".
     * The function should decide about the level of victory from my "points" comparing to
     * points of the others (especially winner). It returns (myFinalPoints/theBestAmongTheOthersPoints) * 100
     *     0 means - I have 0 points
     *    50 means - I have half of the points as the winner
     *   100 means - I have exactly the same number of points as the best other robot
     *   200 means - I have twice as points as the second best
     *  1000 means - the second best has 0 or I'm alone in the world
     *
     *  TODO: discuss the quality of this function - how to improve it?
     *
     *  NOTE: this is, probably, a bullshit - it is not used
     */
    /*public static double calculateVictoryLevel(List<Robot> robots, Robot me) {
        int myFinalPoints = me.getPoints() + me.getEnergy();
        int theWinnerPoints = 0;
        for (Robot robot:robots) {
            if (!robot.equals(me)) {
                theWinnerPoints = Math.max(theWinnerPoints, robot.getPoints() + robot.getEnergy());
            }
        }
        if (theWinnerPoints == 0)
            return 1000;
        return (myFinalPoints/theWinnerPoints) * 100;
    }*/
}
