package cz.muni.fi.fibot.rossumsuniversalrobot;

import cz.muni.fi.fibot.World;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

public class Battery {
 
    private World world;
    public List<Position> batteries;    
    private static Map<Integer, Tarjan> tarjanBatteries;
    
    public Battery(World world) {
        this.world = world;
    
        batteries = new ArrayList<Position>();
        tarjanBatteries = new HashMap<Integer, Tarjan>();
            
        for (int x = 0; x < world.getDimensionX(); x++) {
            for (int y = 0; y < world.getDimensionY(); y++) {
                if (world.containsBattery(x, y)) batteries.add(new Position(x, y));
            }
        }         
    }
    
    public int distance(Position battery, Position position) {
        int distance;
        if (tarjanBatteries.containsKey(battery.toInt())) {
            distance = tarjanBatteries.get(battery.toInt()).distance(position);
        } else {
            Tarjan batteryTarjan = new Tarjan(world);
            batteryTarjan.compute(battery);
            tarjanBatteries.put(battery.toInt(),batteryTarjan);      
            distance = batteryTarjan.distance(position);
        }  
        if (distance > world.getRoundsCount() - world.getRound())
            distance = Tarjan.NO_PATH;
        return distance;
    }
    
    
}
