package cz.muni.fi.fibot.rossumsuniversalrobot;

/**
 * Třída pro logování debugging informací do System.out
 */
public class Log {
    
    /**
     * Úroveň logování debug informací
     * <pre>
     * NO     - žádný výstup 
     * LOW    - základní výstup
     * NEDIUM - podrobný výstup
     * HIGH   - velice podrobný výstup
     * </pre> 
     */
    public enum Level {NO, LOW, MEDIUM, HIGH};
       
    /**
     * Výpis informace odpovídající úrovni logování na konzoli
     *
     * @param logLevel
     *      úroveň do které chci aby se vypisovalo
     * @param output
     *      zpráva, kterou chci vypsat     
     */
    public static void print(Level logLevel, String output) {        
        switch (Parameters.LOG_LEVEL) {
            case LOW:
                if (logLevel == Level.LOW) 
                    System.out.println(output);
                break;
            case MEDIUM: 
                if (logLevel == Level.LOW || logLevel == Level.MEDIUM) 
                    System.out.println(output);
                break;
            case HIGH:  
                    System.out.println(output);
                break;
        }          
    }
    
}
