package cz.muni.fi.fibot.vtipnynazev;

import cz.muni.fi.fibot.Strategy;
import java.util.*;

class State {//state of search = node in graph search
	public Coord m_pos;
	public int m_dir;
	public Strategy.BotAction m_action; //action taken to reach this state = node edge
	public State m_pred; //preceding node in shortest path (for reporting result)

	public int d;
	public boolean visited;
	
	public State(Coord pos, int direction, Strategy.BotAction action, State pred) {
		m_pos = new Coord(pos.m_x, pos.m_y);
		m_dir = direction;
		m_action = action;
		m_pred = pred;
		d = 0;
		visited = false;
	}
}

public class PathFinder {
	
	public static State [][][][]path;
	
	private static State [][][][]pomoc;
	
	public static Coord[] s_fixedList; 

	private static void dijkstra(Coord initPos, int dir, MyWorld world) {
		
		int odkudX = initPos.m_x;
		int odkudY = initPos.m_y;
		
		boolean zmena = true;
		int minD;
		State u;
		
		pomoc[dir][dir][odkudX][odkudY] = new State( new Coord(odkudX, odkudY), dir, Strategy.BotAction.STEP, null); // to STEP bude mozna blbnout
		
		pomoc[dir][dir][odkudX][odkudY].d = 0;

		while(zmena)
		{
			zmena = false;
//			System.out.println("hledam min");
			
			minD = Integer.MAX_VALUE;
			u = null;
			
			for(int x=0;x<world.getDimensionX();x++)
				for(int y=0;y<world.getDimensionY();y++)
					if(!world.containsWall(x,y))
						for(int mydir=0; mydir<4; mydir++)
							if(pomoc[dir][mydir][x][y]!=null)
								if(pomoc[dir][mydir][x][y].d < minD && !pomoc[dir][mydir][x][y].visited)
								{
									minD = pomoc[dir][mydir][x][y].d;
									u = pomoc[dir][mydir][x][y];
									zmena = true;
//									System.out.println("beru: "+x+" "+y+" "+mydir+" "+minD);
								}
			if(!zmena)
				break;

//			System.out.println("jedu");
			u.visited = true;

			// jit dopredu
			int pX=0, pY=0;
			if(	u.m_dir == Coord.LEFT)
				pX+=1;
			else
			if(	u.m_dir == Coord.RIGHT)
				pX-=1;
			else
			if(	u.m_dir == Coord.UP)
				pY+=1;
			else
			if(	u.m_dir == Coord.DOWN)
				pY-=1;

			int x = u.m_pos.m_x+pX;
			int y = u.m_pos.m_y+pY;
			
//			System.out.println("dopredu: "+x+" "+y+" ");
			
			if(x>=0 && x<world.getDimensionX() && y>=0 && y<world.getDimensionY())
				if(!world.containsWall(x,y))
				{
					State next = pomoc[dir][u.m_dir][x][y];
					int d;
					if(next == null)
						d = Integer.MAX_VALUE;
					else
						d = next.d;
					if(d > u.d + 1) {
						if(next == null){
							pomoc[dir][u.m_dir][x][y] = new State( new Coord(x, y), u.m_dir, Strategy.BotAction.STEP, u);
//							System.out.println(x+" "+y);
						}else
						{
							pomoc[dir][u.m_dir][x][y].m_action=Strategy.BotAction.STEP;
							pomoc[dir][u.m_dir][x][y].m_pred=u;
						}
						pomoc[dir][u.m_dir][x][y].d = u.d + 1;
//						System.out.println(x+" "+y+" "+pomoc[dir][u.m_dir][x][y].d);
					}
				}

			// doprava
			{
				int right_dir = (u.m_dir + 3) % 4;
	
				State right = pomoc[dir][right_dir][u.m_pos.m_x][u.m_pos.m_y];
				
				int d;
				if(right == null)
					d = Integer.MAX_VALUE;
				else
					d = right.d;
				if(d > u.d + 1) {
					if(right == null){
						pomoc[dir][right_dir][u.m_pos.m_x][u.m_pos.m_y] = new State( new Coord(u.m_pos.m_x, u.m_pos.m_y), right_dir, Strategy.BotAction.RIGHT, u);
					}else
					{
						pomoc[dir][right_dir][u.m_pos.m_x][u.m_pos.m_y].m_action=Strategy.BotAction.RIGHT;
						pomoc[dir][right_dir][u.m_pos.m_x][u.m_pos.m_y].m_pred=u;
					}
					pomoc[dir][right_dir][u.m_pos.m_x][u.m_pos.m_y].d = u.d + 1;
				}
			}
			// doleva
			{
				int left_dir = (u.m_dir + 1) % 4;
				
				State left = pomoc[dir][left_dir][u.m_pos.m_x][u.m_pos.m_y];
				
				int d;
				if(left == null)
					d = Integer.MAX_VALUE;
				else
					d = left.d;
				if(d > u.d + 1) {
					if(left == null){
						pomoc[dir][left_dir][u.m_pos.m_x][u.m_pos.m_y] = new State( new Coord(u.m_pos.m_x, u.m_pos.m_y), left_dir, Strategy.BotAction.LEFT, u);
					}else
					{
						pomoc[dir][left_dir][u.m_pos.m_x][u.m_pos.m_y].m_action=Strategy.BotAction.LEFT;
						pomoc[dir][left_dir][u.m_pos.m_x][u.m_pos.m_y].m_pred=u;
					}
					pomoc[dir][left_dir][u.m_pos.m_x][u.m_pos.m_y].d = u.d + 1;
				}
			}
		}
	}
	
	public static void precomputePaths(Coord []finalPositions, MyWorld world) {

		s_fixedList = finalPositions;
		path = new State[finalPositions.length][4][world.getDimensionX()][world.getDimensionY()] ;

		for(int f=0; f<finalPositions.length; f++)
		{
/*			if(f>0)															/// smazat pak
				break;
*/			pomoc = new State[4][4][world.getDimensionX()][world.getDimensionY()];

			for(int dir=0; dir<4; dir++)
				dijkstra( finalPositions[f], dir, world);

			for(int x=0;x<world.getDimensionX();x++)
				for(int y=0;y<world.getDimensionY();y++)
					if(!world.containsWall(x,y))
						for(int dir=0; dir<4; dir++)
						{
							int minD = Integer.MAX_VALUE;
							State min = null;
							for(int c=0; c<4; c++)
								if(pomoc[c][dir][x][y]!=null)
									if(pomoc[c][dir][x][y].d < minD)
									{
										minD = pomoc[c][dir][x][y].d;
										min = pomoc[c][dir][x][y];
									}
							if( min == null)
								continue;

							path[f][dir][x][y] = new State( new Coord(x, y), dir, min.m_action, min.m_pred);
							path[f][dir][x][y].d = min.d;
						}
		}
	}

	public static LinkedList<Strategy.BotAction> findPath(Coord initPos, int initDir, Coord finalPos, MyWorld world) {
		//returns null for no path
		if (world.containsWall(finalPos.m_x, finalPos.m_y))
			return null;
		LinkedList<Strategy.BotAction> result = new LinkedList<Strategy.BotAction>();
		boolean visited[][][] = new boolean[Coord.DIMX][Coord.DIMY][4];
		LinkedList<State> q = new LinkedList<State>();
		State now = new State(initPos, initDir, Strategy.BotAction.NOTHING, null);
		q.add(now);
		while (q.size() > 0) {
			now = q.removeFirst();
			if (now.m_pos.m_x == finalPos.m_x && now.m_pos.m_y == finalPos.m_y)
				break;
			if (!visited[now.m_pos.m_x][now.m_pos.m_y][now.m_dir]) {
				visited[now.m_pos.m_x][now.m_pos.m_y][now.m_dir] = true;
				int left = (now.m_dir + 3) % 4;
				if (!visited[now.m_pos.m_x][now.m_pos.m_y][left])
					q.add(new State(now.m_pos, left, Strategy.BotAction.LEFT, now));
				int right = (now.m_dir + 1) % 4;
				if (!visited[now.m_pos.m_x][now.m_pos.m_y][right])
					q.add(new State(now.m_pos, right, Strategy.BotAction.RIGHT, now));
				Coord newPos = new Coord(now.m_pos.m_x + Coord.dir[now.m_dir].m_x, now.m_pos.m_y + Coord.dir[now.m_dir].m_y);
				if (newPos.inside() && 
						!world.containsWall(newPos.m_x, newPos.m_y) &&
						!visited[newPos.m_x][newPos.m_y][now.m_dir])
					q.add(new State(newPos, now.m_dir, Strategy.BotAction.STEP, now));
			}
		}
		if (now.m_pos.m_x == finalPos.m_x && now.m_pos.m_y == finalPos.m_y) {//goal found
			while (now.m_pred != null) {
				result.addFirst(now.m_action);
				now = now.m_pred;
			}
			return result;
		} else
			return null;
	}
	
	public static int getId(Coord coord) {
		for (int i = 0; i < s_fixedList.length; ++i) {
			if (s_fixedList[i].m_x == coord.m_x && s_fixedList[i].m_y == coord.m_y)
				return i;
		}
		return -1;//FIXME chyba : toto nesmi nastat a nastava, ale neni cas to opravovat
	}
																							// dodelat
	public static Strategy.BotAction getNextAction(Coord initPos, int dir, int id) {
		State node = path[id][dir][initPos.m_x][initPos.m_y];
		return node == null ? Strategy.BotAction.NOTHING : node.m_action;
	}
	
	public static int getDistance(Coord initPos, int dir, int id) {
		State node = path[id][dir][initPos.m_x][initPos.m_y];
		return node == null ? Integer.MAX_VALUE : node.d;
	}
	
}
