package cz.muni.fi.fibot.vtipnynazev.purestrat;

import cz.muni.fi.fibot.vtipnynazev.Coord;
import cz.muni.fi.fibot.vtipnynazev.PathFinder;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.vtipnynazev.MyWorld;
import java.util.*;

public class SSnipe implements IPureStrat {
	public Coord m_coord;
	public double m_profit;
	public int m_id;
	
	public double getExpectedProfit(MyWorld world) {
		Coord posNow = new Coord(world.m_me.positionX, world.m_me.positionY);
		int distance = PathFinder.getDistance(posNow, world.m_me.direction, m_id);
		return m_profit / (2 * distance);
	}

	public SSnipe() {}
	
	public SSnipe(MyWorld world, Coord dest, double profit) {
		m_profit = profit;
		m_coord = dest;
		m_id = PathFinder.getId(dest);
	}
	
	public boolean isInterrupted(MyWorld world) {
		Coord posNow = new Coord(world.m_me.positionX, world.m_me.positionY);
		if (posNow.m_x == m_coord.m_x && posNow.m_y == m_coord.m_y)
			return true;
		if (getNextAction(world) == Strategy.BotAction.STEP) {//path blocked
			int newX = world.m_me.positionX + Coord.dir[world.m_me.direction].m_x;
			int newY = world.m_me.positionY + Coord.dir[world.m_me.direction].m_y;
			if (world.containsWall(newX, newY) || world.containsRobot(newX, newY))
				return true;
		}
		return false;
	}
	
	public Strategy.BotAction getNextAction(MyWorld world) {
		Coord posNow = new Coord(world.m_me.positionX, world.m_me.positionY);
		return PathFinder.getNextAction(posNow, world.m_me.direction, m_id);
	}
	
	public IPureStrat clone() {
		SSnipe result = new SSnipe();
		result.m_coord = new Coord(m_coord.m_x, m_coord.m_y);
		result.m_profit = this.m_profit;
		result.m_id = this.m_id;
		return result;
	}	
}
