package cz.muni.fi.fibot.vtipnynazev.purestrat;

import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.vtipnynazev.Coord;
import cz.muni.fi.fibot.vtipnynazev.MyWorld;
import cz.muni.fi.fibot.vtipnynazev.PathFinder;

public class STreasure implements IPureStrat {
	public Coord m_coord;
	public boolean m_finished;
	public int m_id;
	
	public double getExpectedProfit(MyWorld world) {
		int value = world.getTreasureValue(m_coord.m_x, m_coord.m_y);
		Coord posNow = new Coord(world.m_me.positionX, world.m_me.positionY);
		int distance = PathFinder.getDistance(posNow, world.m_me.direction, m_id);
		return 1.0 * value / distance;
	}
	
	public STreasure() {}
	
	public STreasure(MyWorld world, Coord finalPos, double profit) {
		m_coord = finalPos;
		m_finished = false;
		m_id = PathFinder.getId(finalPos);
	}
	
	public boolean isInterrupted(MyWorld world) {
		if (m_finished)//strategy finished
			return true;
		if (!world.containsTreasure(m_coord.m_x, m_coord.m_y))//treasure stolen :/
			return true;
		if (getNextAction(world) == Strategy.BotAction.STEP) {//path no longer valid
			int newX = world.m_me.positionX + Coord.dir[world.m_me.direction].m_x;
			int newY = world.m_me.positionY + Coord.dir[world.m_me.direction].m_y;
			if (world.containsWall(newX, newY) || world.containsRobot(newX, newY))
				return true;
		}
		return false;
	}
	
	public Strategy.BotAction getNextAction(MyWorld world) {
		Coord posNow = new Coord(world.m_me.positionX, world.m_me.positionY);
		if (posNow.m_x == m_coord.m_x && posNow.m_y == m_coord.m_y) {
			m_finished = true;
			return Strategy.BotAction.TAKE;
		} else
			return PathFinder.getNextAction(posNow, world.m_me.direction, m_id);
	}
	
	public IPureStrat clone() {
		STreasure result = new STreasure();
		result.m_coord = m_coord;
		result.m_finished = this.m_finished;
		result.m_id = this.m_id;
		return result;
	}
}
