package cz.muni.fi.fibot.vtipnynazev.purestrat;


import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.vtipnynazev.MyWorld;
import java.util.*;

public class STurnShoot implements IPureStrat {
	public LinkedList<Strategy.BotAction> m_actions;
	public int m_diff;
	public int m_dirThen;
	public double m_profit;
	
	public double getExpectedProfit(MyWorld world) {
		return m_profit;
	}
	
	public STurnShoot() {}
	
	public STurnShoot(int dirNow, int dirThen, double profit) {
		m_profit = profit;
		m_actions = new LinkedList<Strategy.BotAction>();
		m_dirThen = dirThen;
		m_diff = dirNow - dirThen;
		if (Math.abs(m_diff) == 1) {
			if (m_diff < 0)
				m_actions.addLast(Strategy.BotAction.RIGHT);
			else
				m_actions.addLast(Strategy.BotAction.LEFT);
		} else if (Math.abs(m_diff) == 2) {
			m_actions.addLast(Strategy.BotAction.RIGHT);//XXX why right?
			m_actions.addLast(Strategy.BotAction.RIGHT);
		}
		m_actions.addLast(Strategy.BotAction.SHOOT);
	}
	
	public boolean isInterrupted(MyWorld world) {
		if (m_actions.size() == 0)//strategy finished
			return true;
		if (m_actions.size() == 1 && world.m_me.getShot() == null)
			return true;
		return false;
	}
	
	public Strategy.BotAction getNextAction(MyWorld world) {
		Strategy.BotAction result = m_actions.removeFirst();
		return result;
	}
	
	public IPureStrat clone() {
		STurnShoot result = new STurnShoot();
		result.m_diff = this.m_diff;
		result.m_dirThen = this.m_dirThen;
		result.m_actions = this.m_actions;
		if (this.m_actions == null) {
			result.m_actions = null;
		} else {
			result.m_actions = new LinkedList<Strategy.BotAction>();
			result.m_actions.addAll(m_actions);
		}
		
		return result;
	}	
}
